package se.softstuff.nb.nbtranslate.manager;

import java.beans.IntrospectionException;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Collection;
import java.util.Enumeration;
import java.util.concurrent.ExecutionException;
import javax.swing.ListSelectionModel;
import javax.swing.SwingWorker;
import javax.swing.table.TableColumn;
import org.netbeans.api.progress.ProgressHandle;
import org.netbeans.api.progress.ProgressHandleFactory;
import org.netbeans.swing.etable.ETableColumnModel;
import org.netbeans.swing.outline.Outline;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.view.OutlineView;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.BeanNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.Exceptions;
import org.openide.util.NbBundle;
import se.softstuff.nb.nbtranslate.data.NbTranslation;

/**
 *
 * @author stefan
 */
public class SearchPanel extends javax.swing.JPanel implements ExplorerManager.Provider, PropertyChangeListener {

    private OutlineView outlineView;
    private ExplorerManager explorer;
    /**
     * Creates new form SearchPanel
     */
    public SearchPanel() {

        String langName = "language"; //NOI18N
        String langDisplayName = NbBundle.getMessage(SearchPanel.class, "SearchPanel.language.column.header");//NOI18N
        String originName = "original"; //NOI18N
        String originDisplayName = NbBundle.getMessage(SearchPanel.class, "SearchPanel.original.column.header");//NOI18N
        String changedName = "value"; //NOI18N
        String changedDisplayName = NbBundle.getMessage(SearchPanel.class, "SearchPanel.value.column.header");//NOI18N

        String moduleName = "module"; //NOI18N
        String moduleDisplayName = NbBundle.getMessage(SearchPanel.class, "SearchPanel.module.column.header");//NOI18N
        String resouceName = "resource"; //NOI18N
        String resouceDisplayName = NbBundle.getMessage(SearchPanel.class, "SearchPanel.resource.column.header");//NOI18N
        String keyDisplayName = NbBundle.getMessage(SearchPanel.class, "SearchPanel.key.column.header");//NOI18N

        outlineView = new OutlineView(keyDisplayName);
        outlineView.setPropertyColumns(langName, langDisplayName, originName, originDisplayName, changedName, changedDisplayName
                ,moduleName, moduleDisplayName, resouceName, resouceDisplayName);
        outlineView.getOutline().setSelectionMode( ListSelectionModel.SINGLE_SELECTION );


        Outline outline = outlineView.getOutline();
        outline.setRootVisible(false);

        ETableColumnModel columnModel = (ETableColumnModel)outline.getColumnModel();
        TableColumn moduleColumn = outline.getColumn(moduleDisplayName);
        TableColumn resouceColumn = outline.getColumn(resouceDisplayName);

        columnModel.setColumnHidden(moduleColumn, true);
        columnModel.setColumnHidden(resouceColumn, true);


        explorer = new ExplorerManager();


        initComponents();
    }


    @Override
    public ExplorerManager getExplorerManager() {
        return explorer;
    }

    void setTranslation(NbTranslation translation) {
        this.pressentationModel.init(translation);
    }

    private void search(){
        new SearchWorker(searchTextField.getText()).execute();
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pressentationModel = new se.softstuff.nb.nbtranslate.manager.SearchPressentationModel();
        searchTextField = new javax.swing.JTextField();
        searchButton = new javax.swing.JButton();
        resultScrollPane = outlineView;

        setName("Form"); // NOI18N

        searchTextField.setName("searchTextField"); // NOI18N
        searchTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchTextFieldActionPerformed(evt);
            }
        });

        searchButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/se/softstuff/nb/nbtranslate/manager/find.gif"))); // NOI18N
        org.openide.awt.Mnemonics.setLocalizedText(searchButton, org.openide.util.NbBundle.getMessage(SearchPanel.class, "SearchPanel.searchButton.text")); // NOI18N
        searchButton.setName("searchButton"); // NOI18N
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        resultScrollPane.setName("resultScrollPane"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(resultScrollPane, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(searchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 337, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(searchButton)
                        .addGap(0, 181, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(searchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(searchButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(resultScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 490, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
        search();
    }//GEN-LAST:event_searchButtonActionPerformed

    private void searchTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchTextFieldActionPerformed
        search();
    }//GEN-LAST:event_searchTextFieldActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private se.softstuff.nb.nbtranslate.manager.SearchPressentationModel pressentationModel;
    private javax.swing.JScrollPane resultScrollPane;
    private javax.swing.JButton searchButton;
    private javax.swing.JTextField searchTextField;
    // End of variables declaration//GEN-END:variables

    @Override
    public void propertyChange(PropertyChangeEvent evt) {
        if(evt.getPropertyName().equals(SearchElementResultRow.PROP_VALUE)){
            SearchElementResultRow row = (SearchElementResultRow)evt.getSource();
            this.pressentationModel.editRow(row, (String)evt.getNewValue());
        }
    }


    private class SearchWorker extends SwingWorker<Collection<SearchElementResultRow>, Void> {

        private String searchString;

        private ProgressHandle progress;

        public SearchWorker(String searchString) {
            this.searchString = searchString;
            progress = ProgressHandleFactory.createHandle(NbBundle.getMessage(SearchPanel.class, "SearchPanel.progress.title", searchString)); //NOI18N
        }

        @Override
        protected Collection<SearchElementResultRow> doInBackground() throws Exception {
            progress.start();
            Collection<SearchElementResultRow> rows = pressentationModel.search(searchString);
            return rows;
        }

        @Override
        protected void done() {
            progress.finish();

            try {

                Collection<SearchElementResultRow> rows = get();
                Children kids = new SearchElementResultRowChildren(rows);

                //Create a root node:
                Node rootNode = new AbstractNode(kids);
                explorer.setRootContext(rootNode);

            } catch (InterruptedException ex) {
                Exceptions.printStackTrace(ex);
            } catch (ExecutionException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private class SearchElementResultRowChildren extends Children.Keys<SearchElementResultRow> {

        private SearchElementResultRowChildren(Collection<SearchElementResultRow> rows) {
            setKeys(rows);
        }

        @Override
        protected Node[] createNodes(SearchElementResultRow key) {
            try {
                key.addPropertyChangeListener(SearchPanel.this);

                BeanNode beanNode = new BeanNode(key);
                beanNode.setDisplayName(key.getKey());
                return new Node[]{ beanNode };
            } catch (IntrospectionException ex) {
                Exceptions.printStackTrace(ex);
                return new Node[0];
            }
        }

    }
}
